Bug 1272001 - llvm-libs contains unversioned libraries/modules which are in ld path
llvm-libs contains unversioned libraries/modules which are in ld path
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: llvm (Show other bugs)
24
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jan Včelák
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-15 05:18 EDT by Jens Petersen
Modified: 2017-08-08 08:18 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-08 08:18:45 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jens Petersen 2015-10-15 05:18:01 EDT
Description of problem:
llvm-libs contains unversioned .so files that are in the ld path:

/etc/ld.so.conf.d/llvm-x86_64.conf
/usr/lib64/llvm/BugpointPasses.so
/usr/lib64/llvm/LLVMgold.so
/usr/lib64/llvm/libLLVM-3.5.0.so
/usr/lib64/llvm/libLLVM-3.5.so
/usr/lib64/llvm/libLTO.so
/usr/lib64/llvm/readline.so

while this is not a new issue I think I kind of violates
the Fedora Packaging Guidelines so I thought I should report it
since it has come up in the reviews of llvm33, llvm34, llvm35,
and it would be good to get some resolution on this
even if were just an exception of FPC say.
Comment 1 Jens Petersen 2015-10-15 21:08:26 EDT
Some comments:

The simplest solution would be to drop the ld.so.conf.d file, but
that is probably not easy or non-trivial to get working.

/usr/lib64/llvm/libLLVM-3.5.0.so
/usr/lib64/llvm/libLLVM-3.5.so

These are actually versioned (though rpmlint doesn't think so)
so I think they're okay.

So that just leaves:

the 3 .so modules:

/usr/lib64/llvm/BugpointPasses.so
/usr/lib64/llvm/LLVMgold.so
/usr/lib64/llvm/readline.so

(I feel they are less of a concern)

and 

/usr/lib64/llvm/libLTO.so

I am not sure what it is for.
Comment 2 Jens Petersen 2015-10-15 21:19:17 EDT
Actually llvm-libs-3.7.0 no longer has readline.so.

However I noticed that clang-libs has

/usr/lib64/llvm/libclang.so (the llvmXY packages don't ship clang).
Comment 3 Milan Bouchet-Valat 2015-10-16 04:06:45 EDT
Any idea why libLLVM-3.5.0.so includes the version number, but not BugpointPasses.so, LLVMgold.so and libclang.so?
Comment 4 Jan Včelák 2015-10-18 16:24:20 EDT
AFAIK BugpointPasses.so is a library used to test bugpoint utility during make check. It's probably useless in the package.

And as for the unversioned .so files: LLVM supports two build systems - autotools and cmake. Fedora uses autotools, but the upstream is slowly deprecating it. One of the symptoms is unversioned libraries.

The switch to cmake is not easy, because some of the installation paths are broken on Fedora. I tried rebuilding the LLVM and clang using cmake few days ago, and the result looks much better than it used to. And all the libraries are versioned.

I'll give it another round of cleanups and polishing, and I will share the new spec files.
Comment 5 Jens Petersen 2015-10-18 23:31:45 EDT
Thank Jan - that would be awesome IMO.
Comment 6 Jan Kurik 2016-02-24 08:50:46 EST
This bug appears to have been reported against 'rawhide' during the Fedora 24 development cycle.
Changing version to '24'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora24#Rawhide_Rebase
Comment 7 Jan Včelák 2016-06-05 08:35:23 EDT
Current update:

- libLLVMO.so is packaged incorrectly in llvm-libs, should be llvm-devel
- libLTO.so is packaged incorrectly in llvm-devel, it's a plugin for link time optimization, I'm not sure how to make it versioned
- BugpointPasses.so is needed in tests, however required in cmake macros
- LLVMHello.so is an example optimization pass, required in cmake macros
Comment 8 Fedora End Of Life 2017-07-25 15:22:31 EDT
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 9 Fedora End Of Life 2017-08-08 08:18:45 EDT
Fedora 24 changed to end-of-life (EOL) status on 2017-08-08. Fedora 24 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.